﻿<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xml:lang="en">
<head>
  <title>Shift_JIS Full Disclosure - Security - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="description" content="Full disclosure security page detailing the Shift_JIS CSS backslash attack." />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, filtering, standards, compliant, 3.1.1, attack, full disclosure, xss, security, shift_jis, backslash, css" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">Shift_JIS Full Disclosure</h1>

<div id="content">

<p>
  A difference betweeen the behavior of iconv (the utility HTML Purifier
  uses to transform character encodings) and browsers allowed an attacker
  to use the Yen character (<code>5C</code> in Shift_JIS) to trick
  HTML Purifier into outputting a byte-sequence most browsers would
  interpret as a backslash. This could then be used to execute arbitrary
  JavaScript from <abbr>CSS</abbr>.
</p>

<p>
  This vulnerability was reported privately to the vendor by
  <a href="http://d.hatena.ne.jp/teracc/">Takeshi Terada</a>.
  No active exploits are currently known.
</p>

<h2 id="Fix">Fix</h2>

<p>
  This vulnerability was fixed in HTML Purifier 3.1.1 and 2.1.5.
</p>

<h2 id="Details">Details</h2>

<p>
  The large majority of character sets in the world are equivalent
  to US-ASCII in the 7-bit domain. Shift_JIS (as well as Johab) are
  notable exceptions, redefining two byte sequences <code>5C</code>
  and <code>7E</code> to be different characters. In Shift_JIS:
</p>

<table>
  <thead>
    <tr>
      <th>Bytes</th>
      <th>ASCII</th>
      <th>Shift_JIS</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>5C</th>
      <td>\</td>
      <td>¥</td>
    </tr>
    <tr>
      <th>7E</th>
      <td>~</td>
      <td>‾</td>
    </tr>
  </tbody>
</table>

<p>
  This is quite exceptional, and puts users of Shift_JIS in a hard
  place because they have no way of expressing the backslash or
  tilde legitimately. Consequently, browsers treat the byte sequence
  as equivalent to a backslash, even if it renders as a Yen.
</p>

<p>
  Iconv, on the other hand, transforms the <code>5C</code> byte
  sequence to Unicode U+00A5 (in UTF-8, this is <code>C2 A5</code>), the
  correct character for Yen.  This is incorrect behavior, and leads
  to the security vulnerability: HTML Purifier thinks that the backslash
  is actually a Yen, and does not take any appropriate security
  measures.  Then, when the Yen is converted back to <code>5C</code>,
  it gains backslash behavior and can be used to break out of a
  quoted CSS string. Furthermore, traditionally buggy behavior
  will be observed if a backslash is somehow introduced to the
  HTML during processing, as iconv does not know how to convert
  a backslash in UTF-8 back to a backslash in Shift_JIS (hint: it's
  impossible without changing the font).
</p>

<p>
  The fix involves undoing the unnecessary transformation that iconv
  performs.  HTML Purifier generalizes the fix to all character
  encodings with
  <code>HTMLPurifier_Encoder-&gt;testEncodingSupportsASCII()</code>
  by iterating through all printable 7-bit byte sequences and checking
  if conversion to UTF-8 causes a change, in which case appropriate
  measures should be taken. We do not know of any widely used character
  encodings besides Shift_JIS, however, that would be affected by this
  behavior.
</p>

<h2 id="History">History</h2>

<p>
  The vulnerability was reported on May 24, 2008 via email, as a follow
  up to the another <a href="css-backslash">unrelated vulnerability</a> in CSS handling.
  A patch was committed to the public repository on <a href="http://repo.or.cz/w/htmlpurifier.git?a=commit;h=bb16d8eae571dd4e30e3a62cce03d436d46cefaf">May 25, 2008</a>,
  with the summary: <q>Fix Shift_JIS encoding wonkiness with yen symbols and whatnot.</q>
  HTML Purifier 3.1.1 was released on June 19, 2008.
</p>

</div>
</div>

</body>
</html>
